//
//  ServiceGlobals.h
//  AppPiza
//
//  Copyright (c) 2014 CJSC "Computing Forces"
//

#import <Foundation/Foundation.h>


// --- Global data types
typedef enum {
    ServiceOperationStateIdle,
    ServiceOperationStateQueued,
    ServiceOperationStateRunning,
    ServiceOperationStateFinished,
    ServiceOperationStateCancelled,
    ServiceOperationStateFailed
} ServiceOperationState;



// --- Endpoint (Адрес сервиса AppPiza)
extern NSString * const kServiceEndpointURL;


// --- Request errors
// Error domains
extern NSString * const kServiceErrorDomain;

// Error codes
extern NSInteger const kServiceJSONSerializationErrorCode;
extern NSInteger const kServiceJSONDeserializationErrorCode;
extern NSInteger const kServiceHTTPErrorCode;
extern NSInteger const kServiceConnectionErrorCode;

// Error detail keys
extern NSString * const kServiceHTTPStatusErrorUserInfoKey;
extern NSString * const kServiceDetailedErrorUserInfoKey;



// --- Response error codes
extern NSInteger const kServiceResponseNoErrorCode;
extern NSInteger const kServiceResponseConfirmFail;
extern NSInteger const kServiceResponseTooManyConfirmFails;