//
//  NSError+Constructing.m
//
//  Copyright (c) 2014 CJSC "Computing Forces"
//

#import "NSError+Constructing.h"

@implementation NSError (Constructing)

+ (id)errorWithDomain:(NSString *)domain code:(NSInteger)code localizedDescription:(NSString *)localizedDescription {
    NSMutableDictionary *userInfo = [NSMutableDictionary dictionary];
    if (localizedDescription) userInfo[NSLocalizedDescriptionKey] = NSLocalizedString(localizedDescription, nil);
    
    return [NSError errorWithDomain:domain code:code userInfo:userInfo];
}



+ (id)errorWithDomain:(NSString *)domain code:(NSInteger)code localizedDescription:(NSString *)localizedDescription customUserInfo:(NSDictionary *)customUserInfo {
    NSMutableDictionary *userInfo = [[customUserInfo mutableCopy] autorelease];
    if (localizedDescription) userInfo[NSLocalizedDescriptionKey] = NSLocalizedString(localizedDescription, nil);
    
    return [NSError errorWithDomain:domain code:code userInfo:userInfo];
}

@end
