<?php

require_once(__DIR__ . '/../constants.php');


const kApiResponseCodeOk = 0;
const kApiResponseCodeGoodNotFound = 1;
const kApiResponseCodeOrderNotFound = 2;
const kApiResponseCodeBadParameters = 3;
const kApiResponseCodeRequestFailed = 4;
const kApiResponseCodeUnknownError = 5;
const kApiResponseCodeTransactionAlreadyInitiated = 6;
const kApiResponseCodeTransactionNotInitiated = 7;
const kApiResponseCodeWrongConfirmationCode = 8;
const kApiResponseCodeTooManyConfirmationFails = 9;

const kApiResponseMessageOk = 'OK';
//const kApiResponseMessageGoodNotFound = 'Good not found';
//const kApiResponseMessageOrderNotFound = 'Order not found';
//const kApiResponseMessageBadParameters = 'Bad parameters';
//const kApiResponseMessageRequestFailed = 'Request failed';
//const kApiResponseMessageUnknownError = 'Unknown error';
//const kApiResponseMessageTransactionAlreadyInitiated = 'Payment was already initiated';
//const kApiResponseMessageTransactionNotInitiated = 'No invoice ID. Payment was not initiated';

const kApiResponseMessageGoodNotFound = 'Товар не найден';
const kApiResponseMessageOrderNotFound = 'Заказ не найден';
const kApiResponseMessageBadParameters = 'Неверные параметры запроса';
const kApiResponseMessageRequestFailed = 'Ошибка выполнения запроса';
const kApiResponseMessageUnknownError = 'Неизвестная ошибка';
const kApiResponseMessageTransactionAlreadyInitiated = 'Платеж уже инициирован';
const kApiResponseMessageTransactionNotInitiated = 'Платеж ещё не инициирован';
const kApiResponseMessageWrongConfirmationCode = 'Вы ошиблись при вводе кода подтверждения из SMS! Попробуйте ввести его еще раз.';
const kApiResponseMessageTooManyConfirmationFails = 'Вы слишком много раз ввели неверный код! Заказ отменен!';

const kX20ResponseCodeSuccess = 0;
const kX20ResponseWrongCode = 556;
const kX20ResponseWrongCode2 = 500;
const kX20ResponseCodeCancelled = 557;

const kServerTimeFormat = 'Ymd H:i:s';
const kServerTimeOffset = -14400;
const kMaxConfirmFailsCount = 5;



// Response array with custom data
function BuildResponseArray($code, $message, $data) {
    $response = array (
        'code' => $code,
        'message' => $message,
        'response' => $data
    );
    
    return $response;
}



// Response array for unauthorized request
function BuildNotAuthorizedResponseArray() {
    $response = array (
        'code' => kApiResponseCodeNotAuthorized,
        'message' => kApiResponseMessageNotAuthorized
    );
    
    return $response;
}



// Sending JSON request to X20
function SendJsonRequest($url, $jsonData) {
    $req = curl_init();
    $jsonString = json_encode($jsonData);
    
    // Setup request
    curl_setopt($req, CURLOPT_URL, $url);
    curl_setopt($req, CURLOPT_FAILONERROR, 1);
    curl_setopt($req, CURLOPT_FOLLOWLOCATION, 1);
    curl_setopt($req, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($req, CURLOPT_TIMEOUT, 10);
    curl_setopt($req, CURLOPT_POST, 1);
    curl_setopt($req, CURLOPT_POSTFIELDS, $jsonString);
    curl_setopt($req, CURLOPT_HTTPHEADER, array('Content-Type: text/json'));
    
    $resp = curl_exec($req);
    curl_close($req);
    
    // Parse response
    if ($resp === false) return false;
    
    $resp = mb_convert_encoding($resp, 'utf-8', 'cp-1251');
    $responseData = json_decode($resp, true);
    return $responseData;
}

?>